Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JNDynFieldComponent.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JNDynFieldComponent.java	(revision 0)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JNDynFieldComponent.java	(revision 168)
@@ -0,0 +1,515 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+* 
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
+* MA  02110-1301, USA.
+* 
+*/
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 Institute of New Imaging Technologies (INIT): 
+ *   http://www.init.uji.es
+ * Geographic Information research group: 
+ *   http://www.geoinfo.uji.es
+ * Universitat Jaume I, Spain
+ */
+
+/**
+ * 
+ */
+package org.gvsig.tools.swing.impl.dynobject.dynfield;
+
+import java.awt.BorderLayout;
+import java.awt.Component;
+import java.awt.GridBagConstraints;
+import java.awt.GridBagLayout;
+import java.awt.Insets;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.util.List;
+
+import javax.swing.BorderFactory;
+import javax.swing.DefaultListModel;
+import javax.swing.JButton;
+import javax.swing.JList;
+import javax.swing.JPanel;
+import javax.swing.JScrollPane;
+import javax.swing.ListSelectionModel;
+import javax.swing.event.ListSelectionEvent;
+import javax.swing.event.ListSelectionListener;
+
+import org.gvsig.tools.dataTypes.DataTypes;
+import org.gvsig.tools.dynobject.DynField;
+import org.gvsig.tools.service.ServiceException;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent;
+import org.gvsig.tools.swing.api.dynobject.dynfield.ValueField;
+import org.gvsig.tools.swing.spi.DelegatedJFieldComponent;
+
+/**
+ * @author <a href="mailto:reinhold@uji.es">cmartin</a>
+ *
+ */
+public class JNDynFieldComponent  extends DelegatedJFieldComponent implements JDynFieldComponent, ListSelectionListener {
+    
+    
+    private static final int  MINIMUM_LIST_SIZE = 5;
+
+    private JList list;
+
+    private JButton sbutton;
+
+    private JButton jbutton;
+
+//    private DefaultListModel model;
+
+    private JPanel panel;
+
+    private JScrollPane listScrollPane;
+
+    private NValueField items;
+
+    private JPanel upperSubPanel;
+
+//    private DynField defaultField;
+
+
+    
+    /**
+     * @param serviceManager
+     * @param dynObject
+     * @param dynField
+     */
+    public JNDynFieldComponent(ValueField parent, DynField dynField) {
+	super(parent,dynField);
+    }
+
+    private void addElement(Object element) {
+	items.add(element);	
+	this.list.setSelectedIndex(items.getModel().getSize()-1);
+    }
+    
+//    private void addElement(int index, Object item, boolean addItemToInnerList) {
+//	addItem(index,item);
+////	if (addItemToInnerList)
+////	    this.items.add(index,item);
+//	
+//	if (index>=0)
+//	    this.list.setSelectedIndex(index);
+//    }
+    
+    
+//    /**
+//     * @param parent
+//     * @param dynField
+//     * @return
+//     */
+//    private static JDynFieldComponent createComponent(ValueField parent,
+//	    DynField dynField) {
+//	ToolsSwingLocator.getDynObjectSwingManager()
+//	    .createJDynFieldComponent(this, dynField.getElementsType());
+//
+//    }
+
+
+//    /**
+//     * @param object
+//     * @param object2 
+//     */
+//    private void addItem(Integer index, Object value) {
+//	if (value==null) return;
+//	if (index!=null){
+//	    this.items.add(index, value);	
+//	}else
+//	    this.items.add(value);
+////	this.items.setValue(value);
+//    }
+
+    /**
+     * 
+     */
+    protected void afterUI() {
+	//
+//	Object valueItems = getFieldValue();
+//	if (valueItems instanceof List) {
+//	    populateItems((List) valueItems);   
+//	}
+	refresh();
+    }
+
+    private JButton createButton(String text){
+	return ToolsSwingLocator.getUsabilitySwingManager().createJToolButton(text.toString());	
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.JComponent#getComponent()
+     */
+    public Object getComponent() {
+	return this.panel;
+    }
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#getDefaultValue()
+     */
+    public Object getDefaultValue() {
+	return this.getDynField().getDefaultValue();
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#getFieldValue()
+     */
+    @Override
+    public Object getFieldValue() {
+	Object value = getParentValueField().getValue();
+	if (value==null) 
+	    value = getParentValueField().getDefaultValue();
+	return value;
+//	Object value = this..getValue();
+//	if (value==null) 
+//	    value = parentValues.getDefaultValue();
+//	return value;
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#getValue()
+     */
+    @Override
+    public Object getValue() {
+	if (this.list==null)
+	    return null;
+	if (this.getDynField().getType()==DataTypes.STRING)
+	    return this.list.getSelectedValue();
+   	return this.list.getSelectedIndex();	
+    }
+
+
+    /**
+     *  
+     */
+    private void initBoxLayout() { 
+	panel = new JPanel(new BorderLayout(2,2));
+	panel.setBorder(BorderFactory.createTitledBorder(""));
+	
+	JPanel subPanel = new JPanel(new GridBagLayout());
+//	subPanel.setBorder(BorderFactory.createTitledBorder(""));
+
+	list.setVisibleRowCount(4);
+//	list.setLayout(new GridBagLayout());
+	GridBagConstraints c = new GridBagConstraints();
+//	c.insets = new Insets(2, 2, 2, 2);
+//	c.anchor = GridBagConstraints.PAGE_START;
+//	c.ipadx = 0;
+//	c.fill = GridBagConstraints.HORIZONTAL;	   
+	
+	listScrollPane = new JScrollPane(list);
+	listScrollPane.setViewportView(this.list);
+
+	
+	//Adding elements
+	
+	c.insets = new Insets(2, 2, 2, 2);
+	c.anchor = GridBagConstraints.LINE_START;
+	c.ipadx = 0;
+	c.weightx = 0.75;
+	c.fill = GridBagConstraints.HORIZONTAL;	   
+	
+	c.gridx = 0;
+	c.gridy = 0;
+	subPanel.add((Component) component.getComponent(),c);
+	
+//	c.insets = new Insets(2, 2, 2, 2);
+	c.gridx = 1;
+	c.gridy = 0;
+	c.weightx = 0.0;  // 0
+	c.fill = GridBagConstraints.NONE;
+	c.anchor = GridBagConstraints.LINE_END;
+	subPanel.add(jbutton,c);
+	
+	
+	panel.add(subPanel, BorderLayout.NORTH);
+	
+	this.upperSubPanel = panel;
+	
+	subPanel = new JPanel(new GridBagLayout());
+	
+	c.insets = new Insets(2, 2, 2, 2);
+	c.anchor = GridBagConstraints.LINE_START;
+	c.ipadx = 0;
+	c.weightx = 0.75;
+	c.ipady = 40;
+	c.fill = GridBagConstraints.HORIZONTAL;	   
+	
+	c.gridx = 0;
+	c.gridy = 0;
+	subPanel.add(this.listScrollPane,c);
+	
+		
+	c.insets = new Insets(4, 2, 2, 2);
+	c.gridx = 1;
+	c.gridy = 0;
+	c.ipady = 0;
+	c.weightx = 0.0;  // 0
+	c.fill = GridBagConstraints.BASELINE;
+	c.anchor = GridBagConstraints.PAGE_START;
+	subPanel.add(sbutton,c);
+
+	panel.add(subPanel);
+//	c.fill = GridBagConstraints.HORIZONTAL;
+////	c.anchor = GridBagConstraints.LAST_LINE_END; 
+////	c.gridx = 7;      // Cell start at (2,0)
+////	c.gridy = 5;
+////	c.gridheight = 0;  // span of 2
+////	c.gridwidth = 0;  // no span
+//////	c.gridheight = 0;  // no span
+//////	c.weightx = 0.5;  // 
+//	panel.add(sbutton,c);
+
+//	panel.add((Component) component.getComponent(), BorderLayout.PAGE_START);
+	
+	
+
+//	c.fill = GridBagConstraints.HORIZONTAL;
+//	c.ipady = 2;       //reset to default
+//	c.weighty = 1.0;   //request any extra vertical space
+//	c.anchor = GridBagConstraints.PAGE_END; //bottom of space
+//	c.insets = new Insets(10,0,0,0);  //top padding
+//	c.gridx = 1;       //aligned with button 2
+//	c.gridwidth = 2;   //2 columns wide
+//	c.gridy = 2;       //third row
+//	pane.add(button, c);
+//	
+//	JPanel pane = createGridBagLayout((Component) component.getComponent(),jbutton, 1,1,null);	   
+    }
+    
+    protected void initData(){
+	// Creates a list that allows adds and removes
+	this.items = getValueField();
+    }
+    
+    
+    public void initJButtons(){	
+	sbutton = createButton("-");
+	sbutton.setActionCommand("-");
+	sbutton.addActionListener(new ActionListener(){
+
+	    public void actionPerformed(ActionEvent e) {
+		removeElement(list.getSelectedIndex());
+		refresh();
+	    }
+	});
+
+	jbutton = createButton("+");
+	jbutton.setActionCommand("+");
+	jbutton.addActionListener(new ActionListener(){
+
+	    public void actionPerformed(ActionEvent e) {
+		// add at the end of the list
+		if (component.isValid()){
+		    addElement(component.getValue());
+		    refresh();
+		 }		
+	    }});
+    }
+    
+    /**
+     * 
+     */
+    private void initJList() {
+	this.list = new JList(this.items.getModel());
+	this.list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
+	this.list.addListSelectionListener(this);
+	if (this.items.getModel().getSize()>0) 
+	    this.list.setSelectedIndex(0);
+    }
+
+    /**
+     * @throws ServiceException 
+     * 
+     */
+    protected void initUI(){
+	initJList();
+	initJButtons();
+	initBoxLayout();
+//	initListPanel();	
+	refresh();
+    }
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#isValid()
+     */
+    public boolean isValid() {
+	return this.component.isValid();
+    }
+
+    /**
+     * 
+     */
+    private void populateItems(List items) {
+	if (items == null)
+	    return;
+	Object element;
+	for (int i = 0; i < items.size(); i++) {
+	    element = items.get(i);
+	    this.items.add(element);
+	}
+//	if (!items.isEmpty())
+//	    this.list.setSelectedIndex(0);
+    }
+
+    public void refresh(){
+	if ((items.getModel().isEmpty())||(list.getSelectedIndex()<0)){
+	   this.sbutton.setEnabled(false);
+	   this.component.requestFocus();
+	}else
+	    this.sbutton.setEnabled(true);
+    }
+
+    private void removeElement(int ind) {
+	
+	if ((ind>=0)&&(ind<this.items.getModel().getSize()))
+	removeItem(ind);
+	
+	if (items.getModel().getSize()<0)
+	    sbutton.setEnabled(false);
+	else{
+	    if (ind>0)
+		this.list.setSelectedIndex(ind-1);
+	}
+	resize();
+    }
+
+    /**
+     * @param ind
+     */
+    private void removeItem(int ind) {
+//	model.removeElement(model.get(ind));
+	this.items.removeItem(ind);
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#requestFocus()
+     */
+    public void requestFocus() {
+	this.component.requestFocus();
+    }
+
+    /**
+     * 
+     */
+    private void resize() {
+
+//	int list_height =  this.list.getSize().height;
+//	int scrollpane_width = this.listScrollPane.getSize().width;
+//	int scrollpane_height = this.listScrollPane.getSize().height;
+//	int min_height = this.listScrollPane.getMinimumSize().height;
+//
+//	if (scrollpane_height!=list_height)
+//	    if (list_height < min_height)
+//		this.listScrollPane.setSize(scrollpane_width,min_height);
+//	    else
+//		this.listScrollPane.setSize(scrollpane_width,list_height);
+//	this.listScrollPane.revalidate();
+//	this.panel.revalidate();
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#saveStatus()
+     */
+    public void saveStatus() {
+//	for (int i=0;i<this.model.size();i++){
+//	    this.items.addItem(i,this.model.get(i));
+//	}
+	setFieldValue(this.items.toArray());
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#setEnabled(boolean)
+     */
+    public void setEnabled(boolean isEnabled) {
+	if ((isEnabled)&&(this.getDynField().isReadOnly()))
+		return;
+	this.sbutton.setVisible(isEnabled);
+	this.upperSubPanel.setEnabled(isEnabled);
+    }
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#setFieldValue(java.lang.Object)
+     */
+    public void setFieldValue(Object value) {
+	this.getParentValueField().setValue(value);
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.AbstractJDynField#setReadOnly()
+     */
+    @Override
+    protected void setReadOnly() {
+	this.setEnabled(false);
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#setValue(java.lang.Object)
+     */
+    @Override
+    public void setValue(Object value) {
+	if (value instanceof List){
+	   populateItems((List) value);
+	}else{
+	    this.list.setSelectedValue(value, true);		
+	}
+
+    }
+
+
+    /* (non-Javadoc)
+     * @see javax.swing.event.ListSelectionListener#valueChanged(javax.swing.event.ListSelectionEvent)
+     */
+    public void valueChanged(ListSelectionEvent e) {
+	if (list.getSelectedIndex()>=0){
+	    this.component.setValue(this.items.getModel().getElementAt(list.getSelectedIndex()));
+//	    this.list.setVisibleRowCount(model.getSize());
+	    this.sbutton.setVisible(true);
+//	    this.listScrollPane.setVisible(true);
+	}else{
+	    if (this.items.getModel().getSize()<1){
+//		this.sbutton.setVisible(false);
+//		this.listScrollPane.setVisible(false);
+	    }else{
+		int index =this.items.getModel().indexOf(this.items.getModel().firstElement());
+		if (index!=this.list.getSelectedIndex())
+		    this.list.setSelectedIndex(index);
+	    }
+	}
+	refresh();
+	if (!isValid())
+	    this.fireValueChangedEvent();
+    }
+
+
+//    /* (non-Javadoc)
+//     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#getDynField()
+//     */
+//    @Override
+//    public DynField getDynField() {
+//	return this.defaultField;
+//    }
+}
Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JDynObjectDynFieldComponent.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JDynObjectDynFieldComponent.java	(revision 0)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/dynfield/JDynObjectDynFieldComponent.java	(revision 168)
@@ -0,0 +1,202 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+* 
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
+* MA  02110-1301, USA.
+* 
+*/
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 Institute of New Imaging Technologies (INIT): 
+ *   http://www.init.uji.es
+ * Geographic Information research group: 
+ *   http://www.geoinfo.uji.es
+ * Universitat Jaume I, Spain
+ */
+
+/**
+ * 
+ */
+package org.gvsig.tools.swing.impl.dynobject.dynfield;
+
+
+import java.awt.Component;
+
+import org.gvsig.tools.dynobject.DynField;
+import org.gvsig.tools.dynobject.DynObject;
+import org.gvsig.tools.service.Manager;
+import org.gvsig.tools.service.ServiceException;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.dynobject.JDynObjectComponent;
+import org.gvsig.tools.swing.api.dynobject.ValueChangedListener;
+import org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent;
+import org.gvsig.tools.swing.api.dynobject.dynfield.ValueField;
+
+/**
+ * @author <a href="mailto:reinhold@uji.es">cmartin</a>
+ *
+ */
+public class JDynObjectDynFieldComponent implements JDynFieldComponent{
+    
+    private JDynObjectComponent jDynObjectComponent;
+    private DynObject dynObject;
+    private DynField dynField;
+    private Component component;
+
+    /**
+     * @param dynField
+     * @param dynObject
+     * @throws ServiceException 
+     */
+    public JDynObjectDynFieldComponent(DynField dynField, ValueField dynObjectValue) throws ServiceException {
+	this.dynField = dynField;
+	this.dynObject = (DynObject) dynObjectValue.getValue();
+	this.jDynObjectComponent = ToolsSwingLocator.getDynObjectSwingManager().createJDynObjectComponent(getDynObjectValue());
+	this.component = (Component) this.jDynObjectComponent.getComponent();	
+    }
+
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#addValueChangedListener(org.gvsig.tools.swing.api.dynobject.ValueChangedListener)
+     */
+    public void addValueChangedListener(ValueChangedListener listener) {
+	// TODO Auto-generated method stub
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#fireValueChangedEvent()
+     */
+    public void fireValueChangedEvent() {
+	// TODO Auto-generated method stub
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JComponent#getComponent()
+     */
+    public Object getComponent() {
+	return this.jDynObjectComponent.getComponent();
+    }
+    
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#getDefaultValue()
+     */
+    public Object getDefaultValue() {
+	return this.dynField.getDefaultValue();
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#getDynField()
+     */
+    public DynField getDynField() {
+	return this.dynField;
+    }
+
+
+    private DynObject getDynObjectValue(){
+	if (this.dynObject == null)
+	    this.dynObject = (DynObject) getFieldValue();   
+	return this.dynObject;	 
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#getFieldValue()
+     */
+    public Object getFieldValue() {
+	return this.dynObject;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.service.Service#getManager()
+     */
+    public Manager getManager() {
+	// TODO Auto-generated method stub
+	return null;
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#getValue()
+     */
+    public Object getValue() {
+	return getDynObjectValue();
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#isMandatory()
+     */
+    public boolean isMandatory() {
+	return this.dynField.isMandatory();
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#isValid()
+     */
+    public boolean isValid() {
+	return this.jDynObjectComponent.isValid();
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#requestFocus()
+     */
+    public void requestFocus() {
+	this.component.requestFocus();
+	
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#saveStatus()
+     */
+    public void saveStatus() {
+	this.jDynObjectComponent.saveStatus();
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.JDynFieldComponent#setEnabled(boolean)
+     */
+    public void setEnabled(boolean isEnabled) {
+	component.setEnabled(isEnabled);
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.spi.DelegatedJFieldComponent#setFieldValue(java.lang.Object)
+     */
+    public void setFieldValue(Object value) {
+	if (value instanceof DynObject){
+	    this.dynObject = (DynObject) value;
+	}
+    }
+
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.dynfield.ValueField#setValue(java.lang.Object)
+     */
+    public void setValue(Object value) {
+	if (this.dynObject!=null)
+	    this.dynObject = (DynObject) value;	  
+    }
+
+}
Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/AbstractDynObjectModelElement.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/AbstractDynObjectModelElement.java	(revision 0)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/dynobject/AbstractDynObjectModelElement.java	(revision 168)
@@ -0,0 +1,108 @@
+/* gvSIG. Geographic Information System of the Valencian Government
+*
+* Copyright (C) 2007-2008 Infrastructures and Transports Department
+* of the Valencian Government (CIT)
+* 
+* This program is free software; you can redistribute it and/or
+* modify it under the terms of the GNU General Public License
+* as published by the Free Software Foundation; either version 2
+* of the License, or (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
+* MA  02110-1301, USA.
+* 
+*/
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 Institute of New Imaging Technologies (INIT): 
+ *   http://www.init.uji.es
+ * Geographic Information research group: 
+ *   http://www.geoinfo.uji.es
+ * Universitat Jaume I, Spain
+ */
+
+/**
+ * 
+ */
+package org.gvsig.tools.swing.impl.dynobject;
+import org.gvsig.tools.dynobject.DynClass;
+import org.gvsig.tools.dynobject.DynField;
+import org.gvsig.tools.swing.api.dynobject.DynFieldComponentModel;
+
+/**
+ * @author <a href="mailto:reinhold@uji.es">cmartin</a>
+ *
+ */
+public abstract class AbstractDynObjectModelElement implements DynFieldComponentModel{
+    private DynClass theClass;
+    private String fieldName;
+
+    private boolean isReadOnly;
+    private String group; 
+    
+    public AbstractDynObjectModelElement(String fieldName, DynClass theClass, String group){
+	this.theClass = theClass;
+	this.fieldName = fieldName;
+	this.isReadOnly = false;
+	this.group = group;
+    }
+    
+    
+    public boolean equals(Object elem){
+	if (!(elem instanceof DynFieldComponentModel))
+	    return false;
+	DynFieldComponentModel fieldElem = (DynFieldComponentModel) elem;
+	if ( this.getDynField().equals(fieldElem.getDynField()) )
+	    return true;
+	return false;
+    }
+    
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.DynFieldComponentModel#getDynClass()
+     */
+    public DynClass getDynClass() {
+	return this.theClass;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.DynFieldComponentModel#getDynField()
+     */
+    public DynField getDynField() {
+	return this.theClass.getDynField(this.fieldName);
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.DynFieldComponentModel#getGroup()
+     */
+    public String getGroup() {
+	return this.group;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.DynFieldComponentModel#isReadOnly()
+     */
+    public boolean isReadOnly() {
+	return isReadOnly;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.DynFieldComponentModel#setGroup(java.lang.String)
+     */
+    public void setGroup(String group) {
+	this.group = group;
+    }
+
+    /* (non-Javadoc)
+     * @see org.gvsig.tools.swing.api.dynobject.DynFieldComponentModel#setReadOnly(boolean)
+     */
+    public void setReadOnly(boolean isReadOnly) {
+	this.isReadOnly = isReadOnly;
+    }
+}
Index: org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/ToolsSwingDefaultImplLibrary.java
===================================================================
--- org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/ToolsSwingDefaultImplLibrary.java	(revision 167)
+++ org.gvsig.tools/library/trunk/org.gvsig.tools/org.gvsig.tools.swing/org.gvsig.tools.swing.impl/src/main/java/org/gvsig/tools/swing/impl/ToolsSwingDefaultImplLibrary.java	(revision 168)
@@ -25,12 +25,15 @@
 import org.gvsig.tools.library.AbstractLibrary;
 import org.gvsig.tools.library.Library;
 import org.gvsig.tools.library.LibraryException;
+import org.gvsig.tools.service.spi.ServiceManager;
 import org.gvsig.tools.swing.api.ToolsSwingLocator;
-import org.gvsig.tools.swing.api.dynobject.DynObjectSwingManager;
-import org.gvsig.tools.swing.api.dynobject.dynfield.DynFieldComponentFactory;
 import org.gvsig.tools.swing.impl.dynobject.DefaultDynObjectSwingManager;
-import org.gvsig.tools.swing.impl.dynobject.dynfield.NumberFieldComponentFactory;
+import org.gvsig.tools.swing.impl.dynobject.DefaultDynObjectSwingServiceManager;
+import org.gvsig.tools.swing.impl.dynobject.DefaultJDynObjectComponentFactory;
+import org.gvsig.tools.swing.impl.dynobject.dynfield.DefaultJNDynFieldComponentFactory;
+import org.gvsig.tools.swing.impl.dynobject.dynfield.JDynObjectDynfieldComponentFactory;
 import org.gvsig.tools.swing.impl.usability.DefaultUsabilitySwingManager;
+import org.gvsig.tools.swing.spi.ToolsSwingServiceLocator;
 
 /**
  * {@link Library} for the default tools swing implementation.
@@ -39,29 +42,34 @@
  */
 public class ToolsSwingDefaultImplLibrary extends AbstractLibrary {
 
-	@Override
-	protected void doInitialize() throws LibraryException {
-		ToolsSwingLocator
-				.registerDynObjectSwingManager(DefaultDynObjectSwingManager.class);
-		ToolsSwingLocator
-				.registerUsabilitySwingManager(DefaultUsabilitySwingManager.class);
-	}
+    @Override
+    protected void doInitialize() throws LibraryException {
+	ToolsSwingLocator
+		.registerDynObjectSwingManager(DefaultDynObjectSwingManager.class);
+	ToolsSwingLocator
+		.registerUsabilitySwingManager(DefaultUsabilitySwingManager.class);
+	ToolsSwingServiceLocator
+		.registerDynObjectServiceManager(DefaultDynObjectSwingServiceManager.class);
+    }
 
-	@Override
-	protected void doPostInitialize() throws LibraryException {
-		DynObjectSwingManager dsManager = ToolsSwingLocator
-				.getDynObjectSwingManager();
+    @Override
+    protected void doPostInitialize() throws LibraryException {
+	ServiceManager dsManager = ToolsSwingServiceLocator.getServiceManager();
 
-		DynFieldComponentFactory numberFactory = new NumberFieldComponentFactory();
-		dsManager.registerDynFieldComponentFactory(numberFactory,
-				DataTypes.BYTE);
-		dsManager
-				.registerDynFieldComponentFactory(numberFactory, DataTypes.INT);
-		dsManager.registerDynFieldComponentFactory(numberFactory,
-				DataTypes.LONG);
-		dsManager.registerDynFieldComponentFactory(numberFactory,
-				DataTypes.FLOAT);
-		dsManager.registerDynFieldComponentFactory(numberFactory,
-				DataTypes.DOUBLE);
-	}
+	dsManager.addServiceFactory(new DefaultJDynObjectComponentFactory());
+	dsManager.addServiceFactory(new DefaultJNDynFieldComponentFactory(DataTypes.LIST));
+	dsManager.addServiceFactory(new JDynObjectDynfieldComponentFactory());
+	
+	// dsManager.addServiceFactory(new NumberFieldComponentFactory());
+	// dsManager.addServiceFactory(new NumberFieldComponentFactory());
+	// dsManager.addServiceFactory(new NumberFieldComponentFactory());
+
+	// .registerDynFieldComponentFactory(numberFactory, DataTypes.INT);
+	// dsManager.registerDynFieldComponentFactory(numberFactory,
+	// DataTypes.LONG);
+	// dsManager.registerDynFieldComponentFactory(numberFactory,
+	// DataTypes.FLOAT);
+	// dsManager.registerDynFieldComponentFactory(numberFactory,
+	// DataTypes.DOUBLE);
+    }
 }
\ No newline at end of file
